# Generated by Django 4.0.4 on 2022-05-05 05:27

import django.db.models.deletion
import django.utils.timezone
from django.conf import settings
from django.db import migrations, models

import short_stuff.django.models
import short_stuff.lib

import lib.models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name="Checklist",
            fields=[
                (
                    "id",
                    short_stuff.django.models.ShortCodeField(
                        db_index=True,
                        default=short_stuff.lib.gen_shortcode,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("name", models.CharField(max_length=250)),
                (
                    "created_on",
                    models.DateTimeField(
                        db_index=True, default=django.utils.timezone.now
                    ),
                ),
                ("completed", models.BooleanField(db_index=True, default=False)),
                (
                    "completed_on",
                    models.DateTimeField(blank=True, db_index=True, null=True),
                ),
                (
                    "assignee",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "ordering": ("created_on",),
            },
        ),
        migrations.CreateModel(
            name="ChecklistDefinition",
            fields=[
                (
                    "created_on",
                    models.DateTimeField(
                        db_index=True, default=django.utils.timezone.now
                    ),
                ),
                (
                    "updated_on",
                    lib.models.AutoDateTimeField(
                        db_index=True, default=django.utils.timezone.now
                    ),
                ),
                (
                    "id",
                    short_stuff.django.models.ShortCodeField(
                        db_index=True,
                        default=short_stuff.lib.gen_shortcode,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("active", models.BooleanField(db_index=True, default=True)),
                ("name", models.CharField(max_length=200)),
                ("body", models.TextField(blank=True, default="", max_length=5000)),
                (
                    "author",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="ChecklistTaskDefinition",
            fields=[
                (
                    "created_on",
                    models.DateTimeField(
                        db_index=True, default=django.utils.timezone.now
                    ),
                ),
                (
                    "updated_on",
                    lib.models.AutoDateTimeField(
                        db_index=True, default=django.utils.timezone.now
                    ),
                ),
                (
                    "id",
                    short_stuff.django.models.ShortCodeField(
                        db_index=True,
                        default=short_stuff.lib.gen_shortcode,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("active", models.BooleanField(db_index=True, default=True)),
                ("required", models.BooleanField(db_index=True, default=True)),
                ("label", models.CharField(max_length=200)),
                ("body", models.TextField(blank=True, default="", max_length=5000)),
                (
                    "checklist_definition",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="task_definitions",
                        to="workflow.checklistdefinition",
                    ),
                ),
            ],
            options={
                "ordering": ("created_on",),
            },
        ),
        migrations.CreateModel(
            name="ChecklistTask",
            fields=[
                ("completed", models.BooleanField(db_index=True, default=False)),
                (
                    "completed_on",
                    models.DateTimeField(blank=True, db_index=True, null=True),
                ),
                (
                    "id",
                    short_stuff.django.models.ShortCodeField(
                        db_index=True,
                        default=short_stuff.lib.gen_shortcode,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                (
                    "checklist",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="tasks",
                        to="workflow.checklist",
                    ),
                ),
                (
                    "definition",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="tasks",
                        to="workflow.checklisttaskdefinition",
                    ),
                ),
            ],
            options={
                "ordering": ("definition__created_on",),
            },
        ),
        migrations.AddField(
            model_name="checklist",
            name="definition",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name="checklists",
                to="workflow.checklistdefinition",
            ),
        ),
    ]
